#pragma once
#include <avr/io.h>
#include <avr/pgmspace.h>

typedef unsigned char byte;
typedef unsigned word;
union WordRec{unsigned u;int i;byte b[2];char c[2];};
union LongRec{unsigned long d;long l;unsigned u[2];int i[2];byte b[4];char c[4];};
#define NOINIT __attribute__((section(".noinit")))
#define UNUSED __attribute__((unused))
#define elemof(x) (sizeof(x)/sizeof(*(x)))

// Von-Neumannisierter Flash-Zeiger
#define FP(x) ((decltype(x)*)(size_t(&x)+0x8000))
// Flash-Stringzeiger
#define F(x) (const char*)(size_t(PSTR(x))+0x8000)

//#define read_byte_pp(Z) ({byte R;asm("rcall read_byte_pp$mov %0,r0":"=r"(R),"+z"(Z));R;})
//#define read_byte(Z) ({byte R;asm("rcall read_byte_pp$mov %0,r0":"=r"(R):"z"(Z));R;})

void idle();
void delay_ms(word);	// in case of USB is running, wait for SOFs

namespace usb{
 struct EpSz{byte ep,sz;};	// Endpoint-Nummer und FIFO-Gre; sz.7 = kein ZLP
 extern int wLength;		// Lnge des letzten SETUP-Transfers
 extern byte cfg;		// Konfigurationszustand
 int epSend(const void*,int,EpSz); // blockiert
 int epRecv(void*,int,EpSz);	// blockiert
 int ep0Send(const void*,int);	// blockiert
 int ep0Recv(void*addr,int);	// blockiert
 void init();
 void poll();			// blockiert
 inline byte configured() {return cfg;}// USB bereit?
 bool txchar(char c);	// Zeichen senden und, wenn Puffer voll, Flush
 bool flush_output();	// immediately transmit any buffered output
}
